#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"
/*
Funcion de Belegundu

Mimize
f1(x,y)=-2x+y
f2(x,y)=2x+y

constraints
0 <= x <= 5
0 <= y <= 3
****
0 >= -x + y - 1
0 >= x + y - 7
*/

class Belegundu:public MicroAG{
public:  
  Belegundu(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,  double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
  int restricciones(int *genotipo);
};
void Belegundu::evalua(int *cromosoma,double *aptitud){
  
  double x,y;
  x=decodifica(0,cromosoma);
  y=decodifica(1,cromosoma);
  aptitud[0]=-2*x+y;
  aptitud[1]=2*x+y;
}
void Belegundu::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    
    /*
      double fenotipo=0.0,x,y;
      int j;
      int *cadena,*pb;
      cadena=gray_A_binario(ind[i].genotipo);
      pb=cadena;
      for(j=0;j<15;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j],j);//de las potencias de dos reespectivas y
      x=1+fenotipo*4/(pow(base,15)-1); 

      fenotipo=0.0;
      for(j=0;j<14;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j+14],j);//de las potencias de dos reespectivas y
      delete cadena;
      y=1+fenotipo*2/(pow(base,14)-1);

      archivo<<x;
      archivo<<"\t";
      archivo<<y;
      archivo<<"\n";
    */
  }
}
int Belegundu::restricciones(int *genotipo){
  int violadas=0;
  
  double fenotipo=0.0,x,y;
  int i;
  int *cadena,*pb;
  cadena=gray_A_binario(genotipo);
  pb=cadena;
  for(i=0;i<16;i++)//recorrer todo el genotipo, para hacer la suma
    fenotipo+=ldexp(pb[i],i);//de las potencias de dos reespectivas y
  x=fenotipo*5.0/(pow(base,16)-1); 

  fenotipo=0.0;
  for(i=0;i<15;i++)//recorrer todo el genotipo, para hacer la suma
    fenotipo+=ldexp(pb[i+16],i);//de las potencias de dos reespectivas y
  delete cadena;
  y=fenotipo*3.0/(pow(base,15)-1);

  if( 0 < -x + y - 1 ) violadas++;
  if( 0 < x + y - 7 ) violadas++;
  return violadas;
}
int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=1000;
  int M=4;
  int nTope=5;
  int nGenes=2;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7;
  double Pm=(double) 1.0/31.0;
  double *linf=new(double[2]);//=0.1;
  double *lsup=new(double[2]);//=1;
  int *pres=new(int[2]);//=4;
  linf[0]=0.0;
  linf[1]=0.0;
  lsup[0]=5.0;
  lsup[1]=3.0;
  pres[0]=4;
  pres[1]=4;

  int sndelit=50;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);


   Belegundu mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,0,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}
