#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"
#include <sys/timeb.h>
#include <time.h>
/*
  funcion del problema multimodal y multiobjetiva del articulo de Deb
*/

class Deb2:public MicroAG{
public:
  Deb2(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};

void Deb2::evalua(int *cromosoma,double *aptitud){
  double x1,x2,g;
  x1=decodifica(0,cromosoma);
  x2=decodifica(1,cromosoma);
  g=2.0-exp(-pow(((x2-0.2)/0.004),2))-0.8*exp(-pow(((x2-0.6)/0.4),2));
  aptitud[0]=x1;
  aptitud[1]=(double)g/x1;
}

void Deb2::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
  }
}

int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);
  //Funcion del problema 1 de barbosa.(pairs vs unitation..) funcion para paper
  //mejores parametros
  //tampareto=15
  //GMax=200,M=4,nTope=1,nGenes=28,nObjs=2,base=2,subDivs=5;
  // Pc=0.3,Pm=0.035;
  //segundo elitismo 200
  
  // Funcion del problema multimodal y multiobjetivo del articulo de deb.
  //funcion para paper 
  int tamPARETO=100;
  int tamMem=50;
  int GMax=1500;
  int M=4;
  int nTope=2;
  int nGenes=2;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7;
  double Pm=(double)1.0/28.0;
  double *linf=new(double[2]);//=0.1;
  double *lsup=new(double[2]);//=1;
  int *pres=new(int[2]);//=4;
  timeb tiempo1,tiempo2;
  double tiempo;
  linf[0]=0.1;
  linf[1]=0.1;
  lsup[0]=1.0;
  lsup[1]=1.0;
  pres[0]=4;
  pres[1]=4;
  int sndelit=50;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);
 
  Deb2 mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,1,sndelit,pNRem,archivo);
  ftime(&tiempo1);
  mag.Alg();//inicia el algoritmo. 
  ftime(&tiempo2);
  tiempo=difftime(tiempo2.time,tiempo1.time)+(double)(tiempo2.millitm-tiempo1.millitm)/1000.0;
  cout<<"tiempo= "<<tiempo<<" segundos\n";
}

