#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "DrC.h"//funciones de flip() y randreal implementadas en el programa
//del AG que nos envio
#include "randEvolutiva.h"//funciones que nos envio para el primer programa randreal2
extern float Rseed;
extern int Seed;

class Representacion{
 protected:
  int nGenes;
  int *presicion;//y su presicion
  int bits;//numero de "bits" que se necesita.
  int *bitsXgene;
  double *lSup;//Liminte superior
  double *lInf;//limite infierior
  int Cantidad;
  int base;//base la cual me indica si sequiere una representacion binaria o numerica
 public://constructur
  Representacion(int b,int ngenes,double *linf, double *lsup, int *pres, int iguales=1);
  ~Representacion();
  int retBits();//retorna el numero de bits que se utilizan
  int retBits(int i);//retorna el numero de bits por cada gen
  double decodifica (int gen,int *num);//decodifica un gen en su fenotipo
  int * genera();//genera un genotipo aleatorio
  int * inicializa();//genera un genotipo aleatorio
  void copia(int*,int*,int);
  void copia(double*,double*,int);
  int muta(int *,float);//muta un genotipo y regresa el numero de mutaciones
  void cruza(int *, int *,int,int);//cruza dos genotipos
  void imprime(double *num,int n);//imprime el genotipo
  void imprime(int *num,int n);//imprime el genotipo
  int *gray_A_binario(int *g);//calculo de codigo Gray a binario
};

/*
clase que em permite la generacion, y manipulacion de una generacion
*/

class Individuo{
 public:
  double *aptObj;
  int *genotipo;
  long int loc;
};
/*
clase en la que se implementa el algoritmo genetico con cruza y mutacion, y con ruleta como metodo de seleccion proporcional
*/

class MicroAG:public Representacion{
 protected:
  int M;//tamanno de la poblacion
  int nObjs;//numero de objetivos
  int GMax;//Maximo numero de generaciones
  double Pc;//porcentaje de cruza
  double Pm;//porcentaje de mutacion
  int iTot; //Iteraciones totales
  char problema[20];//nombre del problema.
  int numCruzas,numMutaciones;
  int posMemoria;
  int tamPARETO;
  int tamMem;
  int posPARETO;
  Individuo *memoria;
  Individuo *PARETO;
  int cantMem;
  double pPobNRem;
  int pobSRem;
  int sndElit;
  int *hipercubo;
  Individuo *poblacion;//donde se alojara la poblacion
  Individuo *poblacionNueva;
  ofstream archivo;//variable del archivo
  ofstream finales;
  long int lMalla;
  int nDivs;
  double *tamDiv;
  double *inicioMalla;
  int cicloDeReemplazo;
 public:
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  MicroAG(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem, char *arch);
  void iniciar(char *arch);
  //destructor que permite la limpieza de memoria.
  ~MicroAG();
  //almacena al genotipo en el archivo.
  void almacena(double *num, int n);
  //metodo que genera la poblacion inicial
  void generaPoblacion();
  //metodo en el cual se implemento el AG
  void Alg();
  void cruzaYMutacion();
  void seleccion();
  int Domina(Individuo *,Individuo*);
  void nuevaGeneracion();
  void elitismo();
  void iniciaMemoria();
  void memoriza(Individuo *);
  void Mejores(int *,int*);
  void memorizarMejores(int , int);
  void obtPoblacion();
  void eliminaDominados(int*);
  int dominaAPareto(Individuo *);
  void guardaPobEnPareto(int ,int );
  void gPARETO(Individuo *ind);
  int pobUniforme();
  int mejorI(Individuo *pp);
  void actualizaLoc();
  long int cualLoc(Individuo *ind);
  void FunPARETO(Individuo *ind);
  int buscaMasPoblado();
  int masPoblado(int mPoblado,int r);
  int buscaIndConLoc(long int mp);
  void copiaxxx(Individuo *, Individuo *);
  void inicializaDivisiones();
  void sdoElitismo(long);
  virtual void salida(Individuo *){};//,int,int,int,int);
  virtual void evalua(int *cromosoma,double *aptitud){return;};
  virtual int restricciones(int *genotipo){return 0;};
};
