#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"
/*
Funcion de Osyczka (2)
f1(x,y) = -(25(x1-2)**2+(x2-2)**2+(x3-1)**2+(x4-4)**2+(x5-1)**2
f2(x,y) = x1**2+x2**2+x3**2+x4**2+x5**2+x6**2

constraints
0 <= x1,x2,x6 <= 10
1 <= x3,5 <=5
0 <= x4 <= 6
****

0 <= x1 + x2 - 2
0 <= 6 - x1 - x2
0 <= 2 - x2 + x1
0 <= 2 - x1 + 3x2
0 <= 4 - (x3 - 3)**2 - x4
0 <= (x5 - 3)**2 + x6 -4

*/

class Osyczka2:public MicroAG{
public:  
  Osyczka2(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,  double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
  int restricciones(int *genotipo);
};
void Osyczka2::evalua(int *cromosoma,double *aptitud){
  double x1=decodifica(0,cromosoma);
  double x2=decodifica(1,cromosoma);
  double x3=decodifica(2,cromosoma);
  double x4=decodifica(3,cromosoma);
  double x5=decodifica(4,cromosoma);
  double x6=decodifica(5,cromosoma);

  aptitud[0]=-(25*pow(x1-2,2)+pow(x2-2,2)+pow(x3-1,2)+pow(x4-4,2) + pow(x5-1,2));
	       
   aptitud[1]= pow(x1,2)+pow(x2,2) + pow(x3,2)+pow(x4,2) + pow(x5,2) + pow(x6,2);
}
void Osyczka2::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    
    /*
      double fenotipo=0.0,x,y;
      int j;
      int *cadena,*pb;
      cadena=gray_A_binario(ind[i].genotipo);
      pb=cadena;
      for(j=0;j<15;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j],j);//de las potencias de dos reespectivas y
      x=1+fenotipo*4/(pow(base,15)-1); 

      fenotipo=0.0;
      for(j=0;j<14;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j+14],j);//de las potencias de dos reespectivas y
      delete cadena;
      y=1+fenotipo*2/(pow(base,14)-1);

      archivo<<x;
      archivo<<"\t";
      archivo<<y;
      archivo<<"\n";
    */
  }
}
int Osyczka2::restricciones(int *genotipo){
  //  cout<<"cotz\n";
  int violadas=0;
  double x1=decodifica(0,genotipo);
  double x2=decodifica(1,genotipo);
  double x3=decodifica(2,genotipo);
  double x4=decodifica(3,genotipo);
  double x5=decodifica(4,genotipo);
  double x6=decodifica(5,genotipo);
  
  if(0 > x1 + x2 - 2) violadas++;
  if(0 > 6 - x1 - x2) violadas++;
  if(0 > 2 - x2 + x1) violadas++;
  if(0 > 2 - x1 + 3*x2) violadas++;
  if(0 > 4 - pow(x3 - 3,2) - x4) violadas++;
  if(0 > pow(x5 - 3,2) + x6 - 4) violadas++;
  return violadas;
}
int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=7000;
  int M=4;
  int nTope=2;
  int nGenes=6;
  int nObjs=2;
  int base=2;
  int subDivs=30;
  double Pc=0.7;
  double Pm=(double) 1.0/139.0;
  double *linf=new(double[6]);
  double *lsup=new(double[6]);
  int *pres=new(int[6]);
  linf[0]=0.0;
  linf[1]=0.0;
  linf[2]=1.0;
  linf[3]=0.0;
  linf[4]=1.0;
  linf[5]=0.0;

  lsup[0]=10.0;
  lsup[1]=10.0;
  lsup[2]=5.0;
  lsup[3]=6.0;
  lsup[4]=5.0;
  lsup[5]=10.0;

  pres[0]=6;
  pres[1]=6;
  pres[2]=6;
  pres[3]=6;
  pres[4]=6;
  pres[5]=6;
  int sndelit=500;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);


   Osyczka2 mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,0,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}
