#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"

/*
Funcion 2 de schaffer
f1(x)=-x if x<=1
       = -2+x, if 1<x<=3
       =4-x, if 3<x<=4
       =-4+x if x>4
f2(x)= sqr(x-5)

constraints
-5<=x<=10

*/ 

class Schaffer2:public MicroAG{
public:  
  Schaffer2(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};

void Schaffer2::evalua(int *cromosoma,double *aptitud){
  double x=decodifica(0,cromosoma);
  if(x <= 1)
    aptitud[0]= x*-1;
  else if(x<=3)
    aptitud[0]=x-2;
  else if(x<=4)
    aptitud[0]=4-x;
  else aptitud[0]=x-4;
  aptitud[1]=pow((x-5),2);
}
void Schaffer2::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    
    /*
      double x=decodifica(0,ind[i].genotipo);
      double y=decodifica(1,ind[i].genotipo);
      archivo<<x;
      archivo<<"\t";
      archivo<<y;
      archivo<<"\n";
    */
  }
}

int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
 
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=150;
  int M=4;
  int nTope=2;
  int nGenes=1;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7,Pm=(double)1.0/18.0;
  double *linf=new(double[1]);
  double *lsup=new(double[1]);
  int *pres=new(int[1]);
  linf[0]=-5.0;
  lsup[0]=10.0;
  pres[0]=4;
  int sndelit=25;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);

  Schaffer2 mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,1,sndelit, pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}

